#
#  MerlinMP3Player E2
#  Release: 0.93
#  Coded by Dr.Best (c)2009
#  Support: www.dreambox-tools.info
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#

from Plugins.Plugin import PluginDescriptor
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Components.ActionMap import ActionMap, NumberActionMap
from Components.ScrollLabel import ScrollLabel
from Components.ProgressBar import ProgressBar
from Components.FileList import FileList
from Components.Label import Label
from Components.Pixmap import Pixmap
from Components.ConfigList import ConfigList, ConfigListScreen
from Components.Button import Button
from Components.config import *
from Components.MenuList import MenuList
from enigma import ePicLoad
from enigma import eTimer
import random
import merlin_mp3
from enigma import ePoint
from Components.MenuList import MenuList
from enigma import eListboxPythonMultiContent, eListbox, gFont, \
	RT_HALIGN_LEFT, RT_HALIGN_RIGHT, RT_VALIGN_CENTER, RT_HALIGN_CENTER
from enigma import getDesktop
import os
HDSkin = False

config.plugins.merlinmp3player = ConfigSubsection()
config.plugins.merlinmp3player.screensaver = ConfigSelection(default="0", choices = [("0", _("No screensaver")), ("6", _("After 1 minute")),("30", _("After 5 minutes")),("60", _("After 10 minutes")),("180", _("After 30 minutes")),("360", _("After 1 hour"))])
config.plugins.merlinmp3player.sorting = ConfigSelection(default="0", choices = [("0", _("Sort Filenames Ascending")), ("1", _("Sort Filenames Descending")),("2", _("Sort Filedates Ascending")),("3", _("Sort Filedates Descending"))])
config.plugins.merlinmp3player.covers = ConfigSelection(default="7", choices = [("7", _("ID3Tag, Folder, Google-Images")), ("1", _("ID3Tag")),("3", _("ID3Tag, Folder")),("2", _("Folder")),("8", _("No Covers"))])

def main(session,**kwargs):
	session.open(MerlinMP3PlayerStart)

def Plugins(**kwargs):
	return [PluginDescriptor(name="MerlinMP3Player", description=_("MerlinMP3Player"), where = [PluginDescriptor.WHERE_PLUGINMENU,
	        PluginDescriptor.WHERE_EXTENSIONSMENU ], fnc=main)]

class MerlinMP3PlayerStart(Screen):
	global HDSkin
	sz_w = getDesktop(0).size().width()
	if sz_w == 1280:
		# Ueberpruefung, ob das HD Skin Packet installiert wurde...
		if ( os.path.isfile("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/HDSelektion-fs8.png") and os.path.isfile("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/1280_720-fs8.png")):
			HDSkin = True
		else:
			HDSkin = False
	else:
		HDSkin = False

	if HDSkin:
		skin = """
			<screen name="MerlinMP3PlayerStart" position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="selection" position="138,85" size="1021,597" scrollbarMode="showOnDemand" zPosition="1" transparent="0"  backgroundColor="#00000000" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/HDSelektion-fs8.png" position="0,0" size="1280,720" alphatest="on" zPosition="0"/>
			</screen>"""
	else:
		skin = """
			<screen name="MerlinMP3PlayerStart" position="0,0" size="720,576" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="selection" position="149,84" size="417,414" scrollbarMode="showOnDemand" zPosition="1" transparent="0"  backgroundColor="#00000000" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/Selektion-fs8.png" position="0,0" size="720,576" alphatest="on" zPosition="0"/>
			</screen>"""
		
	def __init__(self, session, args = 0):
		self.session = session
		Screen.__init__(self, session)
		self.list = []
		self.list = [ (_("iDream"), 0), (_("Filebrowser"), 1) ]
		self["selection"] = MenuList(self.list)
		self["actions"] = ActionMap(["WizardActions"],
		{
			"back": self.close,
			"ok": self.ok,
		}, -1)
		self.onClose.append(self.__onClose)
		self.CurrentService = self.session.nav.getCurrentlyPlayingServiceReference()
		self.session.nav.stopService()
		merlin_mp3.ClearScreen() #stopService loescht bei mir nicht immer den Bildschirm...deswegen eigene Funktion dafuer...

	def __onClose(self):
		merlin_mp3.Stop()
		self.session.nav.playService(self.CurrentService)

	def ok(self):
		if (self["selection"].getCurrent()[1] == 1):
			self.session.open(MerlinMP3PlayerFileList)
		else:
			self.session.open(iDream)


class iDream(Screen):

	if HDSkin:
		skin = """
			<screen name="iDream" position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="Caption" position="138,85" zPosition="1" size="417,30" font="Regular;21" valign="left" transparent="1" foregroundColor="#047BBC" />
				<widget name="listbox" position="138,125" size="1021,557" scrollbarMode="showOnDemand" zPosition="1" transparent="0"  backgroundColor="#00000000" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/HDSelektion-fs8.png" position="0,0" size="1280,720" alphatest="on" zPosition="0"/>
			</screen>"""
	else:
		skin = """
			<screen name="iDream" position="0,0" size="720,576" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="Caption" position="149,84" zPosition="1" size="417,30" font="Regular;18" valign="left" transparent="1" foregroundColor="#047BBC" />
				<widget name="listbox" position="149,124" size="417,374" scrollbarMode="showOnDemand" zPosition="1" transparent="0"  backgroundColor="#00000000" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/Selektion-fs8.png" position="0,0" size="720,576" alphatest="on" zPosition="0"/>
			</screen>"""
		
	def __init__(self, session):
		self.session = session
		Screen.__init__(self, session)
		self["Caption"] = Label("iDream")
		self.level = 0
		self.id = 0
		self.moveIndex = 0
		self["listbox"] = iDreamList([])
		self.onLayoutFinish.append(self.startRun)
		self["actions"] = ActionMap(["WizardActions", "DirectionActions", "ColorActions", "EPGSelectActions"],
		{
			"ok": self.ok,
			"back": self.close,
			"info": self.showplaying,
			"input_date_time": self.database_maintenance
		}, -1)
		merlin_mp3.iDreamCaptionChanged().append(self.CaptionChanged)
		self.onClose.append(self.__onClose)

	def startRun(self):
		self.updateList()

	def CaptionChanged(self, msg):
		self["Caption"].setText(msg);

	def showplaying(self):
		if (merlin_mp3.isPlaying() == 1):
			self.session.open(MerlinMP3Player,"","", 0, 0, 0)

	def updateList(self):
		self["listbox"].buildList(merlin_mp3.GetiDreamList(self["listbox"].getCurrentIndex(), self.moveIndex, self.level, self.id))

	def ok(self):
		# die ganze Logik und Implementierung fuer iDream ist im C++ Code...Python zeigt nur an...
		self.level = self["listbox"].l.getCurrentSelection()[0][1] # ebene
		self.id = self["listbox"].l.getCurrentSelection()[0][2] # id
		self.moveIndex = self["listbox"].l.getCurrentSelection()[0][6] # [back] oder normales ListItem
		if (self["listbox"].l.getCurrentSelection()[0][4] == 0): #wenn kein abspielbares ListItem...
			self.updateList();
			if (self.moveIndex != -1): # bei [back] an die alte Stelle springen...
				 self["listbox"].moveSelectionTo(self.moveIndex)
		else: # ...ansonsten Player starten
			self.session.open(MerlinMP3Player,"", "", self.level, self.id, self["listbox"].l.getCurrentSelection()[0][5])

	def database_maintenance(self):
		if (self.level == 0): # nur vom Hauptmenu aus...
			self.session.openWithCallback(self.MaintenanceFinished, iDreamDatabaseMaintenance)
	
	def MaintenanceFinished(self, val):
		if val:
			self.id = 0
			self.moveIndex = 0
			self.updateList()

	def __onClose(self):
		merlin_mp3.iDreamCaptionChanged().remove(self.CaptionChanged)

class iDreamDatabaseMaintenance(Screen):

	if HDSkin:
		skin = """
			<screen name="iDreamAddItemDisplay" position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="listbox" position="138,85" size="1021,597" scrollbarMode="showOnDemand" zPosition="1" transparent="0"  backgroundColor="#00000000" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/HDSelektion-fs8.png" position="0,0" size="1280,720" alphatest="on" zPosition="0"/>
			</screen>"""
	else:
		skin = """
			<screen name="iDreamAddItemDisplay" position="0,0" size="720,576" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="listbox" position="149,84" size="417,414" scrollbarMode="showOnDemand" zPosition="1" transparent="0"  backgroundColor="#00000000" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/Selektion-fs8.png" position="0,0" size="720,576" alphatest="on" zPosition="0"/>
			</screen>"""
	def __init__(self, session):
		self.session = session
		Screen.__init__(self, session)
		self.list = []
		self.list = [ (_("Delete iDream database"), 0), (_("Update iDream database"), 1) ]
		self["listbox"] = MenuList(self.list)
		self["actions"] = ActionMap(["WizardActions", "DirectionActions", "ColorActions", "EPGSelectActions"],
		{
			"back": self.CloseDatabaseMaintenance,
			"ok": self.ok,
		}, -1)

	def ok(self):
		if (self["listbox"].getCurrent()[1] == 0):
			self.session.openWithCallback(self.deletedatabase, MessageBox, "Do you really want to delete the iDream database?")
		else:
			self.session.open(MessageBox, "This function is not implemented yet...", type = MessageBox.TYPE_INFO, timeout = 3) 

	def deletedatabase(self,val):
		if val:
			os.remove("/hdd/merlinmp3player.db")
			self.session.open(MessageBox, "iDream database deleted", type = MessageBox.TYPE_INFO, timeout = 3) 
			self.close(1)
	def CloseDatabaseMaintenance(self):
		self.close(0)

class iDreamAddItemDisplay(Screen):

	if HDSkin:
		skin = """
			<screen name="iDreamAddItemDisplay" position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="Display" position="138,85" zPosition="1" size="1021,597" font="Regular;18" halign="center" valign="center" transparent="1" foregroundColor="#047BBC" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/HDSelektion-fs8.png" position="0,0" size="1280,720" alphatest="on" zPosition="0"/>
			</screen>"""
	else:
		skin = """
			<screen name="iDreamAddItemDisplay" position="0,0" size="720,576" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="Display" position="149,84" zPosition="1" size="417,414" font="Regular;18" halign="center" valign="center" transparent="1" foregroundColor="#047BBC" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/Selektion-fs8.png" position="0,0" size="720,576" alphatest="on" zPosition="0"/>
			</screen>"""
	def __init__(self, session, directory):
		self.session = session
		Screen.__init__(self, session)
		self.directory = directory
		self["Display"] = Label("Press OK to start.\n\nPress Exit to leave.")
		self.canClose = True
		self["actions"] = ActionMap(["WizardActions", "DirectionActions", "ColorActions", "EPGSelectActions"],
		{
			"back": self.closeWindow,
			"ok": self.ok,
		}, -1)
		merlin_mp3.iDreamItemAdded().append(self.ItemAdded)
		merlin_mp3.FillPlayListFromDirectoryFinished().append(self.Finished)
		self.onClose.append(self.__onClose)


	def closeWindow(self):
		if self.canClose:
			self.close(0)

	def ok(self):
		self.canClose = False
		merlin_mp3.FillDatabaseFromDirectory(self.directory ,0)

	def ItemAdded(self, msg):
		self["Display"].setText(msg)
	
	def Finished(self, counter):
		text = ("Finished...\n%d songs added to database!\n\nPress Exit to close" % counter)
		self["Display"].setText(text)
		self.canClose = True
	
	def __onClose(self):
		merlin_mp3.iDreamItemAdded().remove(self.ItemAdded)
		merlin_mp3.FillPlayListFromDirectoryFinished().remove(self.Finished)

class MerlinMP3PlayerFileList(Screen):
	if HDSkin:
		skin = """
			<screen name="MerlinMP3PlayerFileList" position="0,0" size="1280,720" title="MerlinMP3Player" flags="wfNoBorder">
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/HDSelektion-fs8.png" position="0,0" size="1280,720" alphatest="on"/>
				<widget name="filelist" position="138,85" size="1021,597" scrollbarMode="showOnDemand" zPosition="1" transparent="0"  backgroundColor="#00000000" />
			</screen>"""
	else:
		skin = """
			<screen name="MerlinMP3PlayerFileList" position="0,0" size="720,576" title="MerlinMP3Player" flags="wfNoBorder">
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/Selektion2-fs8.png" position="0,0" size="720,576" alphatest="on"/>
				<widget name="filelist" position="40,82" size="647,452" scrollbarMode="showOnDemand" zPosition="1" transparent="0"  backgroundColor="#00000000" />
			</screen>"""
		
	def __init__(self, session, args = 0):
		self.session = session
		Screen.__init__(self, session)
		self["filelist"] = FileList(None, showDirectories = True, showFiles = True, matchingPattern = "(?i)^.*\.(mp3|m3u)", useServiceRef = False)
		self["actions"] = ActionMap(["WizardActions", "DirectionActions", "ColorActions", "EPGSelectActions", "merlinActions"],
		{
			"back": self.close,
			"ok": self.ok,
			"pause": self.ok, # 8k
			"info": self.showplaying,
			"green": self.playdirectory,
			"red": self.filldatabase,
			"input_date_time": self.configmenu
		}, -1)

	def filldatabase(self):
		self.session.open(iDreamAddItemDisplay,self["filelist"].getCurrentDirectory())

	def playdirectory(self):
		self.session.open(MerlinMP3Player,self["filelist"].getCurrentDirectory(), "", 0, 0,0)
	
	def showplaying(self):
		if (merlin_mp3.isPlaying() == 1):
			self.session.open(MerlinMP3Player,"","", 0, 0,0)
		
	def startmp3player(self):
		self.session.open(MerlinMP3Player,self["filelist"].getCurrentDirectory(), self["filelist"].getFilename(), 0, 0, 0)

	def ok(self):
		if self["filelist"].canDescent():
			self["filelist"].descent()
		else:
			filename = self["filelist"].getCurrentDirectory() + self["filelist"].getFilename()
			self.startmp3player()
	def configmenu(self):
		self.session.open(MerlinMP3PlayerSetup)
		

class MerlinMP3PlayerSetup(Screen, ConfigListScreen):

	global HDSkin
	if HDSkin:
		skin = """
			<screen name="MerlinMP3PlayerSetup" position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="#003366">
				<widget name="config" position="429,156" size="417,414" zPosition="1" transparent="0" backgroundColor="#00000000" scrollbarMode="showOnDemand" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/Selektion-fs8.png" position="280,72" size="720,576" alphatest="on" zPosition="0"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/red.png" position="460,466" size="12,12" alphatest="on" zPosition="1"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/green.png" position="634,466" size="12,12" alphatest="on" zPosition="1"/>
				<widget name="key_red" position="474,452" zPosition="2" size="140,40" valign="center" halign="left" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />
				<widget name="key_green" position="648,452" zPosition="2" size="140,40" valign="center" halign="left" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />
			</screen>"""

	else:
		skin = """
			<screen name="MerlinMP3PlayerSetup" position="0,0" size="720,576" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="config" position="149,84" size="417,414" zPosition="1" transparent="0" backgroundColor="#00000000" scrollbarMode="showOnDemand" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/Selektion-fs8.png" position="0,0" size="720,576" alphatest="on" zPosition="0"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/red.png" position="194,394" size="12,12" alphatest="on" zPosition="1"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/green.png" position="368,394" size="12,12" alphatest="on" zPosition="1"/>
				<widget name="key_red" position="208,380" zPosition="2" size="140,40" valign="center" halign="left" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />
				<widget name="key_green" position="382,380" zPosition="2" size="140,40" valign="center" halign="left" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />
			</screen>"""

	
	def __init__(self, session):
		Screen.__init__(self, session)

		self["key_red"] = Button(_("Cancel"))
		self["key_green"] = Button(_("OK"))
		
		self["actions"] = ActionMap(["SetupActions", "ColorActions"],
		{
			"green": self.save,
			"red": self.close,
			"cancel": self.close
		}, -2)
		
		MerlinMP3PlayerConfigList = []
		MerlinMP3PlayerConfigList.append(getConfigListEntry(_("Screensaver:"), config.plugins.merlinmp3player.screensaver))
		MerlinMP3PlayerConfigList.append(getConfigListEntry(_("Art Cover:"), config.plugins.merlinmp3player.covers))
		MerlinMP3PlayerConfigList.append(getConfigListEntry(_("Sort Modus:"), config.plugins.merlinmp3player.sorting))
		ConfigListScreen.__init__(self, MerlinMP3PlayerConfigList, session)
		
	def save(self):
		ConfigListScreen.keySave(self)
		configfile.save()

class MerlinMP3Player(Screen):
	global HDSkin
	if HDSkin:
		skin = """
			<screen name="MerlinMP3Player" position="0,0" size="1280,720" title="MerlinMP3Player" flags="wfNoBorder">
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/1280_720-fs8.png" position="0,0" size="1280,720" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/nocover-fs8.png" position="300,204" size="128,128" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/title-fs8.png" position="154,490" size="29,39" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/album-fs8.png" position="152,536" size="36,35" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/artist-fs8.png" position="150,578" size="49,36" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/genre-fs8.png" position="148,623" size="35,37" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/nextsong-fs8.png" position="1117,651" size="36,29" alphatest="on"/>
				<widget name="Current" position="858,317" zPosition="1" size="88,25" font="Regular;21" halign="right" transparent="1" foregroundColor="#B7B7B7" />
				<widget name="Remain" position="949,321" zPosition="1" size="70,20" font="Regular;16" halign="right" transparent="1" foregroundColor="#999999" />
				<widget name="Title" position="200,495" zPosition="1" size="1028,30" font="Regular;26" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#047BBC" />
				<widget name="Album" position="200,542" zPosition="1" size="1028,25" font="Regular;21" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="Artist" position="200,587" zPosition="1" size="1028,25" font="Regular;21" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="Genre" position="200,631" zPosition="1" size="1028,25" font="Regular;21" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="NextTitleCaption" position="1151,655" zPosition="2" size="85,20" font="Regular;16" halign="right" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="NextTitle" position="153,677" zPosition="2" size="1083,20" font="Regular;16" halign="right" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="Progressbar" position="820,293" zPosition="1" size="198,14" transparent="1" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/progressbar-fs8.png" />
				<widget name="coverArt" zPosition="2" position="167,90" size="399,361" transparent="1" alphatest="blend" />
				<widget name="shuffleArt" zPosition="2" position="631,292" size="53,32" transparent="1" alphatest="blend"/>
				<widget name="repeatArt" zPosition="2" position="629,261" size="53,34" transparent="1" alphatest="blend"/>
				<widget name="playArt" zPosition="2" position="906,256" size="30,30" transparent="1" alphatest="blend"/>
				<widget name="pauseArt" zPosition="2" position="908,256" size="29,28" transparent="1" alphatest="blend"/>
				<widget name="nextArt" zPosition="2" position="904,257" size="36,24" transparent="1" alphatest="blend"/>
				<widget name="previousArt" zPosition="2" position="904,257" size="36,26" transparent="1" alphatest="blend"/>
				<widget name="rewindArt" zPosition="2" position="868,258" size="33,22" transparent="1" alphatest="blend"/>
				<widget name="forwardArt" zPosition="2" position="938,258" size="32,23" transparent="1" alphatest="blend"/>
				<widget name="2xArt" zPosition="2" position="901,258" size="37,22" transparent="1" alphatest="blend"/>
				<widget name="4xArt" zPosition="2" position="901,258" size="37,22" transparent="1" alphatest="blend"/>
				<widget name="8xArt" zPosition="2" position="901,258" size="37,22" transparent="1" alphatest="blend"/>
				<widget name="16xArt" zPosition="2" position="901,258" size="37,21" transparent="1" alphatest="blend"/>
			</screen>"""
	else:
		skin = """
			<screen name="MerlinMP3Player" position="0,0" size="720,576" title="MerlinMP3Player" flags="wfNoBorder">
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/720_576-fs8.png" position="0,0" size="720,576" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/nocover-fs8.png" position="156,130" size="128,128" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/title-fs8.png" position="94,357" size="29,39" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/album-fs8.png" position="90,403" size="36,35" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/artist-fs8.png" position="87,443" size="49,36" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/genre-fs8.png" position="88,483" size="35,37" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/nextsong-fs8.png" position="589,514" size="36,29" alphatest="on"/>
				<widget name="Current" position="510,218" zPosition="1" size="68,20" font="Regular;16" halign="right" transparent="1" foregroundColor="#B7B7B7" />
				<widget name="Remain" position="581,220" zPosition="1" size="54,16" font="Regular;12" halign="right" transparent="1" foregroundColor="#999999" />
				<widget name="Title" position="134,363" zPosition="1" size="439,28" font="Regular;24" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#047BBC" />
				<widget name="Album" position="134,410" zPosition="1" size="439,22" font="Regular;16" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="Artist" position="134,450" zPosition="1" size="439,22" font="Regular;16" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="Genre" position="134,490" zPosition="1" size="439,22" font="Regular;16" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="NextTitleCaption" position="622,519" zPosition="2" size="65,16" font="Regular;12" halign="right" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="NextTitle" position="77,542" zPosition="2" size="610,16" font="Regular;12" halign="right" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="Progressbar" position="436,197" zPosition="1" size="198,14" transparent="1" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/progressbar-fs8.png" />
				<widget name="coverArt" zPosition="2" position="100,77" size="238,238" transparent="1" alphatest="blend" />
				<widget name="shuffleArt" zPosition="2" position="370,203" size="53,32" transparent="1" alphatest="blend"/>
				<widget name="repeatArt" zPosition="2" position="370,167" size="53,34" transparent="1" alphatest="blend"/>
				<widget name="playArt" zPosition="2" position="524,162" size="30,30" transparent="1" alphatest="blend"/>
				<widget name="pauseArt" zPosition="2" position="526,162" size="29,28" transparent="1" alphatest="blend"/>
				<widget name="nextArt" zPosition="2" position="522,163" size="36,24" transparent="1" alphatest="blend"/>
				<widget name="previousArt" zPosition="2" position="522,163" size="36,26" transparent="1" alphatest="blend"/>
				<widget name="rewindArt" zPosition="2" position="486,164" size="33,22" transparent="1" alphatest="blend"/>
				<widget name="forwardArt" zPosition="2" position="556,164" size="32,23" transparent="1" alphatest="blend"/>
				<widget name="2xArt" zPosition="2" position="519,165" size="37,22" transparent="1" alphatest="blend"/>
				<widget name="4xArt" zPosition="2" position="519,165" size="37,22" transparent="1" alphatest="blend"/>
				<widget name="8xArt" zPosition="2" position="519,165" size="37,22" transparent="1" alphatest="blend"/>
				<widget name="16xArt" zPosition="2" position="519,165" size="37,21" transparent="1" alphatest="blend"/>
			</screen>"""
		
	def __init__(self, session, directory, filename, level, id, subtable_id):
		self.session = session
		Screen.__init__(self, session)
		self["Current"] = Label()
		self["Remain"] = Label()
		self["Title"] = Label()
		self["Album"] = Label()
		self["Artist"] = Label()
		self["Genre"] = Label()
		self["shuffleArt"] = MerlinMP3PlayerPixmap()
		self["repeatArt"] = MerlinMP3PlayerPixmap()
		self["playArt"] = MerlinMP3PlayerIcons()
		self["pauseArt"] = MerlinMP3PlayerIcons()
		self["nextArt"] = MerlinMP3PlayerIcons()
		self["previousArt"] = MerlinMP3PlayerIcons()
		self["rewindArt"] = MerlinMP3PlayerIcons()
		self["forwardArt"] = MerlinMP3PlayerIcons()
		self["2xArt"] = MerlinMP3PlayerIcons()
		self["4xArt"] = MerlinMP3PlayerIcons()
		self["8xArt"] = MerlinMP3PlayerIcons()
		self["16xArt"] = MerlinMP3PlayerIcons()
		self["NextTitleCaption"] = Label(_("Next Song"))
		self["NextTitle"] = Label()
		self["Progressbar"] = ProgressBar()
		self["coverArt"] = MerlinMP3PlayerPixmap()
		self.ScreenSaverTimer = eTimer()
		self.ScreenSaverTimer.timeout.get().append(self.ScreenSaverTimer_Timeout)
		self["actions"] = ActionMap(["WizardActions", "DirectionActions", "ColorActions", "EPGSelectActions", "MediaPlayerActions", "merlinActions"],
		{
			"back": self.close,
			"stop": self.stopplaying,
			"yellow": self.pause,
			"blue": self.fastforward,
			"red": self.fastbackward,
			"green": self.play,
			"right": self.next,
			"left": self.previous,
			"prevBouquet": self.shufflelist,
			"nextBouquet": self.repeattitle,
			"info": self.getLyrics,
			"up": self.getcurrentplaylist,
			"down": self.getcurrentplaylist,
			"input_date_time": self.showConfig,
			"pause": self.pause, # 8k
		}, -1)
		merlin_mp3.RemainChanged().append(self.RemainChanged)
		merlin_mp3.CurrentChanged().append(self.CurrentChanged)
		merlin_mp3.PercentChanged().append(self.PercentChanged)
		merlin_mp3.TitleChanged().append(self.TitleChanged)
		merlin_mp3.ArtistChanged().append(self.ArtistChanged)
		merlin_mp3.AlbumChanged().append(self.AlbumChanged)
		merlin_mp3.GenreChanged().append(self.GenreChanged)
		merlin_mp3.YearChanged().append(self.YearChanged)
		merlin_mp3.CoverChanged().append(self.CoverChanged)
		merlin_mp3.LyricsChanged().append(self.LyricsChanged)
		merlin_mp3.RepeatTitleChanged().append(self.RepeatTitleChanged)
		merlin_mp3.Finished().append(self.Finished)
		merlin_mp3.NextTitleChanged().append(self.NextTitleChanged)
		merlin_mp3.ShuffleStateChanged().append(self.ShuffleStateChanged)
		merlin_mp3.StatusChanged().append(self.StatusChanged)
		self.directory = directory
		self.filename = filename
		self.level = level
		self.id = id
		self.subtable_id = subtable_id
		self.shuffle = 0
		self.repeat_title = 0
		self.lyrics = ""
		self.currentcover = ""
		self.init = 0
		self.screensaverconfig = int(config.plugins.merlinmp3player.screensaver.value)
		self.coverconfig = int(config.plugins.merlinmp3player.covers.value)
		self.sortingconfig = int(config.plugins.merlinmp3player.sorting.value)
		self.onClose.append(self.__onClose)
		self.onShown.append(self.IconInit)
		self.onLayoutFinish.append(self.startRun)
		
	def IconInit(self):
		if (self.init == 0):
			self["playArt"].updateIcon("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/play-fs8.png")
			self["pauseArt"].updateIcon("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/pause-fs8.png")
			self["nextArt"].updateIcon("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/next-fs8.png")
			self["previousArt"].updateIcon("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/previous-fs8.png")
			self["rewindArt"].updateIcon("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/rewind-fs8.png")
			self["forwardArt"].updateIcon("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/forward-fs8.png")
			self["2xArt"].updateIcon("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/2x-fs8.png")
			self["4xArt"].updateIcon("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/4x-fs8.png")
			self["8xArt"].updateIcon("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/8x-fs8.png")
			self["16xArt"].updateIcon("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/16x-fs8.png")
			self.startmp3()
			self.init = 1
	
	def startRun(self):
		self["coverArt"].hide()
		self["rewindArt"].onShow()
		self["forwardArt"].onShow()
		self["2xArt"].onShow()
		self["4xArt"].onShow()
		self["8xArt"].onShow()
		self["16xArt"].onShow()
		self["playArt"].onShow()
		self["pauseArt"].onShow()
		self["nextArt"].onShow()
		self["previousArt"].onShow()
		self["pauseArt"].hide()
		self["playArt"].hide()
		self["previousArt"].hide()
		self["nextArt"].hide()
		self["rewindArt"].hide()
		self["forwardArt"].hide()
		self["2xArt"].hide()
		self["4xArt"].hide()
		self["8xArt"].hide()
		self["16xArt"].hide()
		self["Progressbar"].setValue(0)

	def stopplaying(self):
		merlin_mp3.Stop()
		self.close(0)

	def showConfig(self):
		if self.ScreenSaverTimer.isActive():
			self.ScreenSaverTimer.stop()
		self.session.openWithCallback(self.showConfigDone, MerlinMP3PlayerSetup)

	def showConfigDone(self):
		self.screensaverconfig = int(config.plugins.merlinmp3player.screensaver.value)
		self.coverconfig = int(config.plugins.merlinmp3player.covers.value)
		self.sortingconfig = int(config.plugins.merlinmp3player.sorting.value)
		merlin_mp3.SetCoverConfig(self.coverconfig)
		self.ResetScreenSaverTimer()

	def shufflelist(self):
		merlin_mp3.ShuffleList()
		self.ResetScreenSaverTimer()
		
	def ShuffleStateChanged(self,msg):
		if (msg != 1):
		    self["shuffleArt"].hide()
		else:
		    self["shuffleArt"].updateCoverArt("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/shuffle-fs8.png")

	def ScreenSaverTimer_Timeout(self):
		if self.ScreenSaverTimer.isActive():
			self.ScreenSaverTimer.stop()
		text = self["Title"].getText()
		if len(text) != 0:
			text = text + " - "
		text = text + self["Artist"].getText()
		self.session.openWithCallback(self.ResetScreenSaverTimer, ScreenSaver, self.currentcover, text)
		
	def ResetScreenSaverTimer(self):
		if self.screensaverconfig != 0:
			if self.ScreenSaverTimer.isActive():
				self.ScreenSaverTimer.stop()
			self.ScreenSaverTimer.start(self.screensaverconfig * 10000)

	def CoverChanged(self,filename):
		self.currentcover = filename
		if len(filename) != 0:
			self["coverArt"].updateCoverArt(filename)
		else:
			self["coverArt"].hide()

	def ArtistChanged(self,msg):
		self["Artist"].setText(msg)
		
	def AlbumChanged(self,msg):
		self["Album"].setText(msg)
		
	def GenreChanged(self,msg):
		self["Genre"].setText(msg)

	def YearChanged(self, msg):
		if (len(msg) != 0):
			text = self["Album"].getText()
			text = text + " (" + msg + ")"
			self["Album"].setText(text)
		
	def getLyrics(self):
		merlin_mp3.GetLyrics();
		self.ResetScreenSaverTimer()
		
	def LyricsChanged(self, msg):
		self.ResetScreenSaverTimer()
		self.lyrics = msg
		self.session.open(LyricsView,msg)
		
	def CurrentChanged(self, msg):
		self["Current"].setText(msg)
		
	def RemainChanged(self, msg):
		self["Remain"].setText(msg)
		
	def PercentChanged(self, msg):
		self["Progressbar"].setValue(msg)
		
	def TitleChanged(self,msg):
		self["Title"].setText(msg)
		
	def startmp3(self):
		if (self.directory != "" ):
			merlin_mp3.Start(self.directory, self.filename,self.coverconfig, self.sortingconfig)
		else:
			if (self.level == 0 and self.id == 0):
				merlin_mp3.getInfos()
			else:
				merlin_mp3.Start_iDreamPlaylist(self.level, self.id, self.subtable_id, self.coverconfig)
		self.ResetScreenSaverTimer()

	def getcurrentplaylist(self):
		self.session.open(CurrentPlaylist)
		self.ResetScreenSaverTimer()

	def play(self):
		back = merlin_mp3.Play()
		self.ResetScreenSaverTimer()
		
	def pause(self):
		merlin_mp3.Pause()
		self.ResetScreenSaverTimer()
		
	def fastforward(self):
		merlin_mp3.FastForward()
		self.ResetScreenSaverTimer()
		
	def fastbackward(self):
		merlin_mp3.FastBackward()
		self.ResetScreenSaverTimer()
		
	def next(self):
		merlin_mp3.Next()
		self.ResetScreenSaverTimer()
		
	def previous(self):
		merlin_mp3.Previous()
		self.ResetScreenSaverTimer()
		
	def NextTitleChanged(self,title, artist):
		if (len(artist) != 0):	
			text = title + " - " + artist
		else:
			text = title
		self["NextTitle"].setText(text)
		
	def Finished(self, result):
		if (result == 1):
			self.close()
		
	def repeattitle(self):
		merlin_mp3.RepeatTitle()
		self.ResetScreenSaverTimer()
		
	def RepeatTitleChanged(self,msg):
		if (msg != 1):
		    self["repeatArt"].hide()
		else:
		    self["repeatArt"].updateCoverArt("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/repeat-fs8.png")
	
	def StatusChanged(self, status):
		if (not (status & 1)):
		    self["playArt"].hide()
		if (not (status & 2)):
		    self["pauseArt"].hide()
		if (not (status & 16)):
		    self["nextArt"].hide()
		if (not (status & 32)):
		    self["previousArt"].hide()
		if ( not (status & 4)):
		    self["forwardArt"].hide()
		if (not (status & 8)):
		    self["rewindArt"].hide()
		if (not (status & 1024)):
				self["2xArt"].hide()
		if (not (status & 2048)):
				self["4xArt"].hide()
		if (not (status & 4096)):
				self["8xArt"].hide()
		if (not (status & 8192)):
				self["16xArt"].hide()
		if (status & 1):
		    self["playArt"].show()
		elif (status & 2):
		    self["pauseArt"].show()
		elif (status & 16):
		    self["nextArt"].show()
		elif (status & 32):
		    self["previousArt"].show()
		elif (status & 4):
		    self["forwardArt"].show()
		elif (status & 8):
		    self["rewindArt"].show()
		if ((status & 4) or (status & 8)):
			if (status & 1024):
				self["2xArt"].show()
			if (status & 2048):
				self["4xArt"].show()
			if (status & 4096):
				self["8xArt"].show()
			if (status & 8192):
				self["16xArt"].show()

	def __onClose(self):
		if self.ScreenSaverTimer.isActive():
			self.ScreenSaverTimer.stop()
		merlin_mp3.RemainChanged().remove(self.RemainChanged)
		merlin_mp3.CurrentChanged().remove(self.CurrentChanged)
		merlin_mp3.PercentChanged().remove(self.PercentChanged)
		merlin_mp3.TitleChanged().remove(self.TitleChanged)
		merlin_mp3.ArtistChanged().remove(self.ArtistChanged)
		merlin_mp3.AlbumChanged().remove(self.AlbumChanged)
		merlin_mp3.GenreChanged().remove(self.GenreChanged)
		merlin_mp3.YearChanged().remove(self.YearChanged)
		merlin_mp3.CoverChanged().remove(self.CoverChanged)
		merlin_mp3.LyricsChanged().remove(self.LyricsChanged)
		merlin_mp3.NextTitleChanged().remove(self.NextTitleChanged)
		merlin_mp3.RepeatTitleChanged().remove(self.RepeatTitleChanged)
		merlin_mp3.ShuffleStateChanged().remove(self.ShuffleStateChanged)
		merlin_mp3.StatusChanged().remove(self.StatusChanged)
		merlin_mp3.Finished().remove(self.Finished)

class MerlinMP3PlayerPixmap(Pixmap):

	def __init__(self):
		Pixmap.__init__(self)
		self.coverArtFileName = ""
		self.picload = ePicLoad()
		self.picload.PictureData.get().append(self.paintCoverArtPixmapCB)

	def onShow(self):
		Pixmap.onShow(self)
		self.picload.setPara((self.instance.size().width(), self.instance.size().height(), 1, 1, False, 1, "#00000000"))

	def paintCoverArtPixmapCB(self, picInfo=None):
		ptr = self.picload.getData()
		if ptr != None:
			self.instance.setPixmap(ptr.__deref__())
			self.instance.show()

	def updateCoverArt(self, filename):
		new_coverArtFileName = filename
		if (self.coverArtFileName != new_coverArtFileName) or ( new_coverArtFileName == "/tmp/.id3cover") :
			self.coverArtFileName = new_coverArtFileName
			self.picload.startDecode(self.coverArtFileName)
		else:
			self.instance.show()

class MerlinMP3PlayerIcons(Pixmap):

	def __init__(self):
		Pixmap.__init__(self)
		self.IconFileName = ""
		self.picload = ePicLoad()
		self.picload.PictureData.get().append(self.paintIconPixmapCB)

	def onShow(self):
		Pixmap.onShow(self)
		self.picload.setPara((self.instance.size().width(), self.instance.size().height(), 1, 1, False, 1, "#00000000"))

	def paintIconPixmapCB(self, picInfo=None):
		ptr = self.picload.getData()
		if ptr != None:
			self.instance.setPixmap(ptr.__deref__())

	def updateIcon(self, filename):
		new_IconFileName = filename
		if (self.IconFileName != new_IconFileName):
			self.IconFileName = new_IconFileName
			self.picload.startDecode(self.IconFileName)

class CurrentPlaylist(Screen):
	global HDSkin
	if HDSkin:
		skin = """
			<screen name="CurrentPlaylist" position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="listbox" position="138,85" size="1021,597" zPosition="1" transparent="0"  backgroundColor="#00000000" foregroundColor="#B7B7B7" scrollbarMode="showOnDemand" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/HDSelektion-fs8.png" position="0,0" size="1280,720" alphatest="on" zPosition="0"/>
			</screen>"""
	else:
		skin = """
			<screen name="CurrentPlaylist" position="0,0" size="720,576" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="listbox" position="40,82" size="647,452" zPosition="1" transparent="0"  backgroundColor="#00000000" foregroundColor="#B7B7B7" scrollbarMode="showOnDemand" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/Selektion2-fs8.png" position="0,0" size="720,576" alphatest="on" zPosition="0"/>
			</screen>"""
	def __init__(self, session):
		self.session = session
		Screen.__init__(self, session)
		self["listbox"] = CurrentPlayList([])
		self.onLayoutFinish.append(self.startRun)
		self["actions"] = ActionMap(["WizardActions", "DirectionActions", "ColorActions", "merlinActions"],
		{
			"ok": self.ok,
			"back": self.close,
			"pause": self.ok, # 8k
			"green": self.ok,
			
		}, -1)
		self.list = list

	def startRun(self):
		
		self["listbox"].buildList(merlin_mp3.GetCurrentPlayList())

	def ok(self):
		sel = self["listbox"].l.getCurrentSelection()[0][0]
		if sel is None:
			return
		merlin_mp3.PlaySelectedItem(sel)
		self.close()


class LyricsView(Screen):
	global HDSkin
	if HDSkin:
		skin = """
			<screen name="LyricsView" position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="lyric_text" position="138,85" size="1021,597" font="Regular;30" zPosition="1" transparent="0"  backgroundColor="#00000000" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/HDSelektion-fs8.png" position="0,0" size="1280,720" alphatest="on" zPosition="0"/>
			</screen>"""
	else:
		skin = """
			<screen name="LyricsView" position="0,0" size="720,576" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="lyric_text" position="149,84" size="417,414" font="Regular;22" zPosition="1" transparent="0"  backgroundColor="#00000000" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/Selektion-fs8.png" position="0,0" size="720,576" alphatest="on" zPosition="0"/>
			</screen>"""

	def __init__(self, session, text):
		self.session = session
		Screen.__init__(self, session)
		self["lyric_text"] = ScrollLabel()
		self.lyric = text
		self.onLayoutFinish.append(self.startRun)
		self["actions"] = ActionMap(["WizardActions", "DirectionActions", "ColorActions", "EventViewActions"],
		{
			"back": self.close,
			"pageUp": self.pageUp,
			"pageDown": self.pageDown,
		}, -1)

	def startRun(self):
		self["lyric_text"].setText(self.lyric)

	def pageUp(self):
		self["lyric_text"].pageUp()

	def pageDown(self):
		self["lyric_text"].pageDown()	

class ScreenSaver(Screen):
	global HDSkin
	if HDSkin:
		skin = """
			<screen name="ScreenSaver" position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="coverArt" zPosition="2" position="100,77" size="300,300" transparent="1" alphatest="blend" />
				<widget name="display" position="100,382" zPosition="1" size="1028,30" font="Regular;26" valign="left" transparent="1" foregroundColor="#005B00" />
			</screen>"""
	else:
		skin = """
			<screen name="ScreenSaver" position="0,0" size="720,576" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="coverArt" zPosition="2" position="100,77" size="238,238" transparent="1" alphatest="blend" />
				<widget name="display" position="100,320" zPosition="1" size="439,28" font="Regular;24" valign="left" transparent="1" foregroundColor="#005B00" />
			</screen>"""
	
	def __init__(self, session, filename, text):
		self.session = session
		Screen.__init__(self, session)
		self["display"] = Label(text)
		self["coverArt"] = MerlinMP3PlayerPixmap()
		self["actions"] = ActionMap(["WizardActions", "DirectionActions", "ColorActions", "EventViewActions"],
		{
			"back": self.close,
			"right": self.close,
			"left": self.close,
			"up": self.close,
			"down": self.close,
			"ok": self.close,
			"pageUp": self.close,
			"pageDown": self.close,
			"yellow": self.close,
			"blue": self.close,
			"red": self.close,
			"green": self.close,
			"right": self.close,
			"left": self.close,
			"prevBouquet": self.close,
			"nextBouquet": self.close,
			"info": self.close,

		}, -1)
		merlin_mp3.CoverChanged().append(self.CoverChanged)
		merlin_mp3.TitleChanged().append(self.TitleChanged)
		merlin_mp3.ArtistChanged().append(self.ArtistChanged)
		self.currentcover = filename
		self.title = ""
		self.onClose.append(self.__onClose)
		self.onLayoutFinish.append(self.startRun)
		self.onShown.append(self.CoverInit)
		self.moveTimer = eTimer()
		self.moveTimer.timeout.get().append(self.moveTimer_Timeout)

	def startRun(self):
		self["coverArt"].onShow()

	def moveTimer_Timeout(self):
		if HDSkin:
			x = random.randint(0, 980)
			y = random.randint(0, 420)
			self["display"].move(ePoint(x,y+305))
		else:
			x = random.randint(0, 482)
			y = random.randint(0, 338)
			self["display"].move(ePoint(x,y+243))
		self["coverArt"].move(ePoint(x,y))
		

	def ArtistChanged(self,msg):
		if len(self.title) != 0:
			self["display"].setText(self.title + " - " + msg)
		else:
			self["display"].setText(msg)

	def TitleChanged(self,msg):
		self.title = msg

	def CoverInit(self):
		self.CoverChanged(self.currentcover)
		self.moveTimer.start(5000)

	def CoverChanged(self,filename):
		if len(filename) != 0:
			self["coverArt"].updateCoverArt(filename)
		else:
			self["coverArt"].hide()

	def __onClose(self):
		if self.moveTimer.isActive():
			self.moveTimer.stop()
		merlin_mp3.CoverChanged().remove(self.CoverChanged)
		merlin_mp3.TitleChanged().remove(self.TitleChanged)
		merlin_mp3.ArtistChanged().remove(self.ArtistChanged)

class CurrentPlayList(MenuList):
	def __init__(self, list, enableWrapAround = True):
		MenuList.__init__(self, list, enableWrapAround, eListboxPythonMultiContent)
		self.l.setFont(0, gFont("Regular", 18))
		self.l.setFont(1, gFont("Regular", 18))
	def postWidgetCreate(self, instance):
		MenuList.postWidgetCreate(self, instance)
		instance.setItemHeight(20)

	def buildList(self,listnew):
		self.list=[]
		width = self.l.getItemSize().width()
		for items in listnew:
			res = [ items ]
			res.append((eListboxPythonMultiContent.TYPE_TEXT, 0, 0, width, 20, 0, RT_HALIGN_LEFT, items[1]))
			self.list.append(res)
		self.l.setList(self.list)
		self.moveToIndex(merlin_mp3.GetCurrentIndex())

class iDreamList(MenuList):
	def __init__(self, list, enableWrapAround = True):
		MenuList.__init__(self, list, enableWrapAround, eListboxPythonMultiContent)
		self.l.setFont(0, gFont("Regular", 18))
		self.l.setFont(1, gFont("Regular", 18))
	def postWidgetCreate(self, instance):
		MenuList.postWidgetCreate(self, instance)
		instance.setItemHeight(20)

	def getCurrentIndex(self):
		return self.instance.getCurrentIndex()
		
	def moveSelectionTo(self,index):
		self.moveToIndex(index)

	def buildList(self,listnew):
		self.list=[]
		width = self.l.getItemSize().width()
		moveIndex = 0
		for items in listnew:
			res = [ items ]
			if (items[0] != "[Back]" and items[4] != 1):
				res.append((eListboxPythonMultiContent.TYPE_TEXT, 0, 0, width, 20, 0, RT_HALIGN_LEFT, ("%s (%s)" % (items[0], items[3]))))
			else:
				if ( items[4] == 1):
					res.append((eListboxPythonMultiContent.TYPE_TEXT, 0, 0, width, 20, 0, RT_HALIGN_LEFT, items[0]))
				else:
					res.append((eListboxPythonMultiContent.TYPE_TEXT, 0, 0, width, 20, 0, RT_HALIGN_CENTER, items[0]))
			
			self.list.append(res)
		self.l.setList(self.list)
		self.moveToIndex(0)
